--[[
	OneShotProspect
	A World of Warcraft AddOn by Alex Schumaker
]]--

OSP = LibStub("AceAddon-3.0"):NewAddon("OneShotProspect", "AceConsole-3.0", "AceEvent-3.0")

local _ 
local prof = {}
local useitem

function OSP:OnInitialize()
	local f = CreateFrame("Button", "OSPbutton", nil, "SecureActionButtonTemplate")
	f:SetAttribute("type", "macro")
	f:SetText("Prospect")
	OSP:UpdateMacro()
	OSP:RegisterEvent("SKILL_LINES_CHANGED")
	OSP:RegisterEvent("PLAYER_ENTERING_WORLD")
end

function OSP:PLAYER_ENTERING_WORLD()
	if not OSP:CheckForMacro() then
		CreateMacro("OSP", "SPELL_MISC_CONJUREMANAJEWEL", 
			"/run OSP:UpdateMacro() \n/click OSPbutton", nil)
	end
end

function OSP:SKILL_LINES_CHANGED()
	OSP:GetProfs()
end

function OSP:GetProfs()
	local prof1, prof2 = GetProfessions()
	if prof1 == 10 or prof2 == 10 then
		prof = {"Milling","Herb"}
	else
		prof = {"Prospecting","Metal & Stone"}
	end
end



function OSP:GetNextOre()
	for i = 0,NUM_BAG_SLOTS do 
		for j = 1, GetContainerNumSlots(i) do 
			local _,stack = GetContainerItemInfo(i,j)
			if GetContainerItemID(i,j) then
				local name,_,_,_,_,_,subclass = GetItemInfo(GetContainerItemID(i,j))
				if name == useitem and stack >= 5 then 
					return i.." "..j
				end 
			end
		end
	end
end

function OSP:UpdateMacro()
	local itemname = GameTooltip:GetItem()
	if itemname then
		local name,_,_,_,_,_,subclass = GetItemInfo(itemname)
		if subclass == prof[2] then
			useitem = name
		end
	end

	if OSP:GetNextOre() then
		OSPbutton:SetAttribute("macrotext", "/cast "..prof[1].."\n/use " .. OSP:GetNextOre())
	end
end

function OSP:CheckForMacro()
	local global,perChar = GetNumMacros()
	for i = 1, global do 
		local name = GetMacroInfo(i)
		if name == "OSP" then
			return true
		end
	end
	return false
end
















